package de.masterfacture.ProductionPlanning.Interfaces;

import java.util.ArrayList;

/**
 * The interface for a path finder algorithm.
 * @author macke
 *
 */
public interface IPathAlgorithm
{
	/**
	 * Calculates the shortest path between two given nodes in a graph.
	 * @param from The start node.
	 * @param to The end node.
	 * @return The shortest path between the two nodes (list of nodes to go through).
	 */
	ArrayList<INode> calculatePath(String from, String to);
}