package de.masterfacture.ProductionPlanning.RouteCalculation;

import java.util.ArrayList;

import de.masterfacture.ProductionPlanning.Interfaces.*;

public class PPTest
{

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		// the graph in which to find the path
		IGraph pp = new ProductionPlant();
		// the algorithm that is used to find the shortest path
		IPathAlgorithm astar = new AStarAlgorithm(pp);
		
		// set start and end town
		String start = "Warehouse";
		String end = "Ramp";
		if (args.length == 2)
		{
			start = args[0];
			end = args[1];
		}
		
		System.out.println();
		System.out.println("Calculating path from " + start + " to " + end + "...");			

		if (pp.getNode(start) == null)
		{
			System.out.println("Part does not exist: " + start);	
			return;
		}
		if (pp.getNode(end) == null)
		{
			System.out.println("Part does not exist: " + end);	
			return;
		}
		
		// do the path calculation
		ArrayList<INode> path = astar.calculatePath(end, start);
		
		// display the shortest path
		if (path == null)
		{
			System.out.println("No path found!");
		}
		else
		{
			System.out.println();
			StringBuilder sb = new StringBuilder();
			double completeDistance = 0;
			for (INode step: path)
			{
				if (step.getClass() == Conveyor.class)
					completeDistance += ((Conveyor)step).getLength();
				sb.append(step + "\n");
			}
			System.out.println("Path calculated (complete distance: " + completeDistance + ")");
			System.out.println();
			System.out.print(sb);
		}
	}

}
